<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 256
0dbfs = 1
nchnls = 2

#define MAX_SIZE #4096#

gisize init 1024
gkchange init 0

pyinit
pyexeci "decorrelation.py"

giir1 ftgen 100, 0, $MAX_SIZE, 2, 0
giir2 ftgen 101, 0, $MAX_SIZE, 2, 0

gifftsizes ftgen 0, 0, 8, -2, 128, 256, 512, 1024, 2048, 4096, 0

	opcode getIr, 0, ii
ichan, ifn xin
index init 0
idummy init 0
isize pycall1i "get_ir_length", -1
isize = gisize
doit:
	ival pycall1i "get_ir_point", ichan, index
	tableiw ival, index, ifn

loop_lt index, 1, isize, doit

	endop

instr 1  ; Inputs and control
	gainput inch 1
;	gainput diskin2 "file.wav", 1
	gkon_decorrelation invalue "on_decorrelation"
	gklevel_decorrelation invalue "level_decorrelation"
endin


	instr 2  ; Generate new IR and load it to ftable giir
inew_seed = p4

kfftsize invalue "fftsize"
gisize table i(kfftsize), gifftsizes

; Clear tables
giir1 ftgen 100, 0, $MAX_SIZE, 2, 0
giir2 ftgen 101, 0, $MAX_SIZE, 2, 0

kmax_jump1 init -1
kmax_jump2 init -1

icur_seed pycall1i "new_seed", inew_seed ;-1 means use system time

;Chan 1
imax_jump = i(kmax_jump1)
ichan = 1
pycalli "new_ir_for_channel", gisize, ichan, imax_jump
getIr 1, giir1

;Chan 2
imax_jump = i(kmax_jump2)
ichan = 2
pycalli "new_ir_for_channel", gisize, ichan, imax_jump
getIr 2, giir2

gkchange init 1
turnoff 
	endin


instr 17 ; Kendall method

if gkchange == 1 then
	reinit  dconvreinit
	gkchange = 0
endif

dconvreinit:
prints "Reinit ftconv\n"

if gkon_decorrelation == 1 then
	aout1 ftconv gainput, giir1, 1024, 0, gisize
	aout2 ftconv gainput, giir2, 1024, 0, gisize
	aout1 = aout1*gklevel_decorrelation
	aout2 = aout2*gklevel_decorrelation
else
	aout1 = gainput*gklevel_decorrelation
	aout2 = gainput*gklevel_decorrelation
endif
outch 1, aout1, 2, aout2
endin

</CsInstruments>
<CsScore>
i 1 0 3600
i 2 0 -1
i 17 0 3600
</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>731</x>
 <y>285</y>
 <width>406</width>
 <height>347</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>170</r>
  <g>170</g>
  <b>127</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>8</x>
  <y>5</y>
  <width>386</width>
  <height>167</height>
  <uuid>{4c919985-3409-41f4-8fbb-43e8dfb20801}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Kendall method</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="background">
   <r>129</r>
   <g>149</g>
   <b>91</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>5</borderradius>
  <borderwidth>3</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>39</x>
  <y>46</y>
  <width>80</width>
  <height>25</height>
  <uuid>{d4fdb81c-b8c8-4f79-bb49-d0cec19e5607}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Enable</label>
  <alignment>left</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBCheckBox">
  <objectName>on_decorrelation</objectName>
  <x>21</x>
  <y>48</y>
  <width>20</width>
  <height>20</height>
  <uuid>{66b6c878-2a39-499a-b162-8761109dfc60}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <selected>true</selected>
  <label/>
  <pressedValue>1</pressedValue>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBKnob">
  <objectName>level_decorrelation</objectName>
  <x>301</x>
  <y>23</y>
  <width>74</width>
  <height>72</height>
  <uuid>{9a962245-1ac4-41bc-ac0e-2b08a18b5224}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.18000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>0.01000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>298</x>
  <y>93</y>
  <width>80</width>
  <height>25</height>
  <uuid>{c207900d-6fa8-426d-bd4f-1217f25145e4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Level</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>fftsize</objectName>
  <x>124</x>
  <y>78</y>
  <width>80</width>
  <height>30</height>
  <uuid>{6bc6ec6e-1b7f-4fe1-b9d2-db3ee0d91f15}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>128</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>256</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>512</name>
    <value>2</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>1024</name>
    <value>3</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>2048</name>
    <value>4</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>4096</name>
    <value>5</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>3</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBScope">
  <objectName/>
  <x>115</x>
  <y>182</y>
  <width>171</width>
  <height>156</height>
  <uuid>{bef815d2-059d-40e2-a89e-5212e38d91b6}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <value>-255.00000000</value>
  <type>lissajou</type>
  <zoomx>1.00000000</zoomx>
  <zoomy>1.00000000</zoomy>
  <dispx>1.00000000</dispx>
  <dispy>1.00000000</dispy>
  <mode>0.00000000</mode>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>24</x>
  <y>123</y>
  <width>186</width>
  <height>30</height>
  <uuid>{836065f9-5dd9-4755-b071-7d25c84d7c14}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>New Coefficients</text>
  <image>/</image>
  <eventLine>i2 0 1 -1</eventLine>
  <latch>false</latch>
  <latched>true</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>26</x>
  <y>77</y>
  <width>98</width>
  <height>31</height>
  <uuid>{a51ee335-0ed7-40a7-88a6-576f7de39900}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>FIlter length</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {43690, 43690, 32639}
ioText {8, 5} {385, 302} label 0.000000 0.00100 "" center "DejaVu Sans" 18 {65280, 65280, 65280} {33024, 38144, 23296} nobackground noborder Kendall method
ioText {36, 86} {80, 25} label 0.000000 0.00100 "" left "Lucida Grande" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Enable
ioCheckbox {21, 48} {20, 20} on on_decorrelation
ioKnob {301, 23} {74, 72} 1.000000 0.000000 0.010000 0.180000 level_decorrelation
ioText {298, 93} {80, 25} label 0.000000 0.00100 "" center "DejaVu Sans" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Level
ioMenu {124, 78} {80, 30} 3 303 "128,256,512,1024,2048,4096" fftsize
ioGraph {115, 182} {171, 156} lissajou 1.000000 -255 
ioButton {24, 123} {186, 30} event 1.000000 "" "New Coefficients" "/" i2 0 1 -1
ioText {43, 89} {99, 26} label 0.000000 0.00100 "" right "Arial" 14 {0, 0, 0} {63232, 62720, 61952} nobackground noborder FIlter length
</MacGUI>
